package demoplugin;

import org.zeroturnaround.javarebel.ClassResourceSource;
import org.zeroturnaround.javarebel.Integration;
import org.zeroturnaround.javarebel.IntegrationFactory;
import org.zeroturnaround.javarebel.Plugin;

import demoplugin.cbp.MemoryUsageServletCBP;

public class DemoPlugin implements Plugin {

  @Override
  public void preinit() {
    Integration integration = IntegrationFactory.getInstance();
    ClassLoader cl = getClass().getClassLoader();

    // patch the bytecode of MemoryUsageServlet when it's first loaded by the classloader.
    integration.addIntegrationProcessor(cl,
        "demoapp.MemoryUsageServlet",
        new MemoryUsageServletCBP());
  }

  @Override
  public boolean checkDependencies(ClassLoader cl, ClassResourceSource crs) {
    // only enable the plugin if the demoapp.MemoryUsageServlet class is in the classpath
    return crs.getClassResource("demoapp.MemoryUsageServlet") != null;
  }

  @Override
  public String getId() {
    return "demo-plugin";
  }

  @Override
  public String getName() {
    return null;
  }

  @Override
  public String getDescription() {
    return null;
  }

  @Override
  public String getAuthor() {
    return null;
  }

  @Override
  public String getWebsite() {
    return null;
  }

  @Override
  public String getSupportedVersions() {
    return null;
  }

  @Override
  public String getTestedVersions() {
    return null;
  }
}
